// I intend to start fights.

#![allow(unused)]

const START: u16 = 0xACE1;
static mut STATE: u16 = START;

pub fn step() {
    unsafe {
        STATE ^= STATE >> 7;
        STATE ^= STATE << 9;
        STATE ^= STATE >> 13;
    }
}

pub fn get_bit() -> bool {
    step();
    let bit = unsafe { STATE } & 1;
    bit != 0
}

pub fn get_byte() -> u8 {
    for _ in 0..8 {
        step();
    }
    (unsafe { STATE } & 0xFF) as u8
}

pub fn get_word() -> u16 {
    ((get_byte() as u16) << 8) + get_byte() as u16
}

pub fn get_dword() -> u32 {
    ((get_word() as u32) << 16) + get_word() as u32
}

pub fn get_qword() -> u64 {
    ((get_dword() as u64) << 32) + get_dword() as u64
}

pub fn get_dqword() -> u128 {
    ((get_qword() as u128) << 64) + get_qword() as u128
}
